{ config, lib, pkgs, ... }:
let
  cfg = config.helpers.webservices;
in
{
  options.helpers.webservices = lib.mkOption {
    description = "Webservice helper";
    default = {};
    type = with lib.types; attrsOf (submodule {
      options = {
        port = lib.mkOption {
          type = port;
        };
        # fqdn = lib.mkOption {
        #   type = bool;
        #   default = true;
        # };
        # localOnly = lib.mkOption {
        #   type = bool;
        #   default = false;
        # };
        auth = lib.mkOption {
          type = bool;
          default = true;
        };
      };
    });
  };
  config = { # lib.attrsets.mapAttrs (fqdn: name: {

   # helpers.webservices = (lib.mapAttrs (name: nameAttrs: lib.mkIf nameAttrs.fqdn {
   #   port = 
   # }) cfg);
    # networking.hosts."127.0.0.1" = (lib.attrsets.mapAttrsToList (name: nameattrs: "${name}") cfg) ++ (lib.attrsets.mapAttrsToList (name: nameattrs: if nameattrs.fqdn then "${name}.${config.networking.fqdn}" else "" ) cfg);
    # networking.hosts."127.0.0.1" = builtins.attrNames cfg ++ (lib.mapAttrsToList (name: nameattrs: lib.mkIf nameattrs.fqdn "${name}.${config.networking.fqdn}") cfg);
    networking.hosts."127.0.0.1" = builtins.attrNames cfg;
  # lifted from https://nixos.wiki/wiki/Nginx#Authentication_via_PAM
  # also https://github.com/NixOS/nixpkgs/issues/117578
  # Have not tested to see which of these can be re-enabled. Not a fan of killing all that stuff just for pam.
  # Maybe copy /etc/shadow to /run/keys via colmena?
  # security.pam.services.nginx.setEnvironment = false;
  # systemd.services.nginx.serviceConfig = {
  #   SupplementaryGroups = [ "shadow" ];
  #   NoNewPrivileges = lib.mkForce false;
  #   PrivateDevices = lib.mkForce false;
  #   ProtectHostname = lib.mkForce false;
  #   ProtectKernelTunables = lib.mkForce false;
  #   ProtectKernelModules = lib.mkForce false;
  #   RestrictAddressFamilies = lib.mkForce [ ];
  #   LockPersonality = lib.mkForce false;
  #   MemoryDenyWriteExecute = lib.mkForce false;
  #   RestrictRealtime = lib.mkForce false;
  #   RestrictSUIDSGID = lib.mkForce false;
  #   SystemCallArchitectures = lib.mkForce "";
  #   ProtectClock = lib.mkForce false;
  #   ProtectKernelLogs = lib.mkForce false;
  #   RestrictNamespaces = lib.mkForce false;
  #   SystemCallFilter = lib.mkForce "";
  # };


    # services.nginx.virtualHosts."nfo".locations."/subdomain"
    services.nginx = {
      enable = lib.mkDefault true;
      additionalModules = [ pkgs.nginxModules.pam ];
      virtualHosts = lib.attrsets.mapAttrs (fqdn: name: {
        enableACME = config.security.acme.acceptTerms;
        forceSSL = config.security.acme.acceptTerms;
        locations."/" = {
          proxyPass = "http://127.0.0.1:${toString name.port}";
          # extraConfig = lib.mkIf name.localOnly ''
          #   allow 127.0.0.1;
          #   deny all;
          # '';
          proxyWebsockets = true;
        };
        # extraConfig = lib.mkIf name.auth ''
        #   auth_pam  "Password Required";
        #   auth_pam_service_name "nginx";
        # '';
      }) cfg;
    };
  };
}
