{ config, lib, ... }:
let
  fqdn = "invidious.${config.networking.fqdn}";
in {
  services.invidious = {
    enable = true;
    port = 3255;
    domain = "${fqdn}";
    settings = {
      https_only = config.security.acme.acceptTerms;
      external_port = if config.security.acme.acceptTerms then 443 else 80;
    };
  };
  helpers.webservices."${fqdn}".port = config.services.invidious.port;
}
